Bullet Collision Detection & Physics Library: btPolyhedralConvexShape Class Reference

Bullet Collision Detection & Physics Library

Public Member Functions | Protected Attributes | List of all members
btPolyhedralConvexShape Class Referenceabstract

The btPolyhedralConvexShape is an internal interface class for polyhedral convex shapes. More...

`#include <btPolyhedralConvexShape.h>`

Inheritance diagram for btPolyhedralConvexShape:
[legend]
Collaboration diagram for btPolyhedralConvexShape:
[legend]

## Public Member Functions
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btPolyhedralConvexShape ()
virtual | ~btPolyhedralConvexShape ()
virtual bool | initializePolyhedralFeatures (int shiftVerticesByMargin=0)
| optional method mainly used to generate multiple contact points by clipping polyhedral features (faces/edges) experimental/work-in-progress More...
const btConvexPolyhedron * | getConvexPolyhedron () const
virtual btVector3 | localGetSupportingVertexWithoutMargin (const btVector3 &vec) const
virtual void | batchedUnitVectorGetSupportingVertexWithoutMargin (const btVector3 *vectors, btVector3 *supportVerticesOut, int numVectors) const
virtual void | calculateLocalInertia (btScalar mass, btVector3 &inertia) const
virtual int | getNumVertices () const =0
virtual int | getNumEdges () const =0
virtual void | getEdge (int i, btVector3 &pa, btVector3 &pb) const =0
virtual void | getVertex (int i, btVector3 &vtx) const =0
virtual int | getNumPlanes () const =0
virtual void | getPlane (btVector3 &planeNormal, btVector3 &planeSupport, int i) const =0
virtual bool | isInside (const btVector3 &pt, btScalar tolerance) const =0
Public Member Functions inherited from btConvexInternalShape
| BT_DECLARE_ALIGNED_ALLOCATOR ()
virtual | ~btConvexInternalShape ()
virtual btVector3 | localGetSupportingVertex (const btVector3 &vec) const
const btVector3 & | getImplicitShapeDimensions () const
void | setImplicitShapeDimensions (const btVector3 &dimensions)
| warning: use setImplicitShapeDimensions with care changing a collision shape while the body is in the world is not recommended, it is best to remove the body from the world, then make the change, and re-add it alternatively flush the contact points, see documentation for 'cleanProxyFromPairs' More...
void | setSafeMargin (btScalar minDimension, btScalar defaultMarginMultiplier=0.1f)
void | setSafeMargin (const btVector3 &halfExtents, btScalar defaultMarginMultiplier=0.1f)
void | getAabb (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const
| getAabb's default implementation is brute force, expected derived classes to implement a fast dedicated version More...
virtual void | getAabbSlow (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const
virtual void | setLocalScaling (const btVector3 &scaling)
virtual const btVector3 & | getLocalScaling () const
const btVector3 & | getLocalScalingNV () const
virtual void | setMargin (btScalar margin)
virtual btScalar | getMargin () const
btScalar | getMarginNV () const
virtual int | getNumPreferredPenetrationDirections () const
virtual void | getPreferredPenetrationDirection (int index, btVector3 &penetrationVector) const
virtual int | calculateSerializeBufferSize () const
virtual const char * | serialize (void *dataBuffer, btSerializer *serializer) const
| fills the dataBuffer and returns the struct name (and 0 on failure) More...
Public Member Functions inherited from btConvexShape
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btConvexShape ()
| not supported on IBM SDK, until we fix the alignment of btVector3 More...
virtual | ~btConvexShape ()
btVector3 | localGetSupportVertexWithoutMarginNonVirtual (const btVector3 &vec) const
btVector3 | localGetSupportVertexNonVirtual (const btVector3 &vec) const
btScalar | getMarginNonVirtual () const
void | getAabbNonVirtual (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const
virtual void | project (const btTransform &trans, const btVector3 &dir, btScalar &minProj, btScalar &maxProj, btVector3 &witnesPtMin, btVector3 &witnesPtMax) const
Public Member Functions inherited from btCollisionShape
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btCollisionShape ()
virtual | ~btCollisionShape ()
virtual void | getBoundingSphere (btVector3 &center, btScalar &radius) const
virtual btScalar | getAngularMotionDisc () const
| getAngularMotionDisc returns the maximum radius needed for Conservative Advancement to handle time-of-impact with rotations. More...
virtual btScalar | getContactBreakingThreshold (btScalar defaultContactThresholdFactor) const
void | calculateTemporalAabb (const btTransform &curTrans, const btVector3 &linvel, const btVector3 &angvel, btScalar timeStep, btVector3 &temporalAabbMin, btVector3 &temporalAabbMax) const
| calculateTemporalAabb calculates the enclosing aabb for the moving object over interval [0..timeStep) result is conservative More...
bool | isPolyhedral () const
bool | isConvex2d () const
bool | isConvex () const
bool | isNonMoving () const
bool | isConcave () const
bool | isCompound () const
bool | isSoftBody () const
bool | isInfinite () const
| isInfinite is used to catch simulation error (aabb check) More...
virtual const char * | getName () const =0
int | getShapeType () const
virtual btVector3 | getAnisotropicRollingFrictionDirection () const
| the getAnisotropicRollingFrictionDirection can be used in combination with setAnisotropicFriction See Bullet/Demos/RollingFrictionDemo for an example More...
void | setUserPointer (void *userPtr)
| optional user data pointer More...
void * | getUserPointer () const
void | setUserIndex (int index)
int | getUserIndex () const
virtual void | serializeSingleShape (btSerializer *serializer) const

## Protected Attributes
btConvexPolyhedron * | m_polyhedron
Protected Attributes inherited from btConvexInternalShape
btVector3 | m_localScaling
btVector3 | m_implicitShapeDimensions
btScalar | m_collisionMargin
btScalar | m_padding
Protected Attributes inherited from btCollisionShape
int | m_shapeType
void * | m_userPointer
int | m_userIndex

## Additional Inherited Members
Protected Member Functions inherited from btConvexInternalShape
| btConvexInternalShape ()

## Detailed Description

The btPolyhedralConvexShape is an internal interface class for polyhedral convex shapes.

Definition at line 25 of file btPolyhedralConvexShape.h.

## Constructor & Destructor Documentation

## § btPolyhedralConvexShape()

btPolyhedralConvexShape::btPolyhedralConvexShape | ( |  | ) |

Definition at line 27 of file btPolyhedralConvexShape.cpp.

## § ~btPolyhedralConvexShape()

btPolyhedralConvexShape::~btPolyhedralConvexShape | ( |  | ) |
| virtual

Definition at line 33 of file btPolyhedralConvexShape.cpp.

## Member Function Documentation

## § batchedUnitVectorGetSupportingVertexWithoutMargin()

void btPolyhedralConvexShape::batchedUnitVectorGetSupportingVertexWithoutMargin | ( | const btVector3 * | vectors,
|  | btVector3 * | supportVerticesOut,
|  | int | numVectors
| ) |  | const
| virtual

Implements btConvexShape.

Reimplemented in btConvexPointCloudShape, btTriangleShape, btBox2dShape, btConvexHullShape, btBoxShape, and btConvexTriangleMeshShape.

Definition at line 367 of file btPolyhedralConvexShape.cpp.

## § BT_DECLARE_ALIGNED_ALLOCATOR()

btPolyhedralConvexShape::BT_DECLARE_ALIGNED_ALLOCATOR | ( |  | ) |

## § calculateLocalInertia()

void btPolyhedralConvexShape::calculateLocalInertia | ( | btScalar | mass,
|  | btVector3 & | inertia
| ) |  | const
| virtual

Implements btCollisionShape.

Reimplemented in btBox2dShape, btTriangleShape, and btBoxShape.

Definition at line 404 of file btPolyhedralConvexShape.cpp.

## § getConvexPolyhedron()

const btConvexPolyhedron* btPolyhedralConvexShape::getConvexPolyhedron | ( |  | ) | const
| inline

Definition at line 46 of file btPolyhedralConvexShape.h.

## § getEdge()

virtual void btPolyhedralConvexShape::getEdge | ( | int | i,
|  | btVector3 & | pa,
|  | btVector3 & | pb
| ) |  | const
| pure virtual

Implemented in btBox2dShape, btBoxShape, btConvexPointCloudShape, btConvexHullShape, btBU_Simplex1to4, btTriangleShape, and btConvexTriangleMeshShape.

## § getNumEdges()

virtual int btPolyhedralConvexShape::getNumEdges | ( |  | ) | const
| pure virtual

Implemented in btBox2dShape, btBoxShape, btConvexPointCloudShape, btConvexHullShape, btBU_Simplex1to4, btConvexTriangleMeshShape, and btTriangleShape.

## § getNumPlanes()

virtual int btPolyhedralConvexShape::getNumPlanes | ( |  | ) | const
| pure virtual

Implemented in btBox2dShape, btBoxShape, btTriangleShape, btConvexPointCloudShape, btConvexHullShape, btBU_Simplex1to4, and btConvexTriangleMeshShape.

## § getNumVertices()

virtual int btPolyhedralConvexShape::getNumVertices | ( |  | ) | const
| pure virtual

Implemented in btBox2dShape, btBoxShape, btConvexPointCloudShape, btConvexHullShape, btBU_Simplex1to4, btConvexTriangleMeshShape, and btTriangleShape.

## § getPlane()

virtual void btPolyhedralConvexShape::getPlane | ( | btVector3 & | planeNormal,
|  | btVector3 & | planeSupport,
|  | int | i
| ) |  | const
| pure virtual

Implemented in btBox2dShape, btBoxShape, btTriangleShape, btConvexPointCloudShape, btConvexHullShape, btBU_Simplex1to4, and btConvexTriangleMeshShape.

## § getVertex()

virtual void btPolyhedralConvexShape::getVertex | ( | int | i,
|  | btVector3 & | vtx
| ) |  | const
| pure virtual

Implemented in btBox2dShape, btBoxShape, btConvexPointCloudShape, btConvexHullShape, btBU_Simplex1to4, btConvexTriangleMeshShape, and btTriangleShape.

## § initializePolyhedralFeatures()

bool btPolyhedralConvexShape::initializePolyhedralFeatures | ( | int | shiftVerticesByMargin = `0` | ) |
| virtual

optional method mainly used to generate multiple contact points by clipping polyhedral features (faces/edges) experimental/work-in-progress

Definition at line 43 of file btPolyhedralConvexShape.cpp.

## § isInside()

virtual bool btPolyhedralConvexShape::isInside | ( | const btVector3 & | pt,
|  | btScalar | tolerance
| ) |  | const
| pure virtual

Implemented in btBox2dShape, btBoxShape, btTriangleShape, btConvexPointCloudShape, btConvexHullShape, btBU_Simplex1to4, and btConvexTriangleMeshShape.

## § localGetSupportingVertexWithoutMargin()

btVector3 btPolyhedralConvexShape::localGetSupportingVertexWithoutMargin | ( | const btVector3 & | vec | ) | const
| virtual

Implements btConvexShape.

Reimplemented in btConvexPointCloudShape, btConvexHullShape, btTriangleShape, btBox2dShape, btBoxShape, and btConvexTriangleMeshShape.

Definition at line 324 of file btPolyhedralConvexShape.cpp.

## Member Data Documentation

## § m_polyhedron

btConvexPolyhedron* btPolyhedralConvexShape::m_polyhedron
| protected

Definition at line 31 of file btPolyhedralConvexShape.h.

The documentation for this class was generated from the following files:

- btPolyhedralConvexShape.h
- btPolyhedralConvexShape.cpp